<?php
/*
 *   class.browser.php - Browser Class for Indexer
 *   Copyright 2011 Saravana Kumar.A <saravanakumar.a.o@gmail.com>
 *      
 */



class Browser
{
	public $Root_dir;
	public $Title;
	public $Message;
	public $Exceptions;
	
	// Iconset
	public $Icons = array(
	                'exe'=>array('Executable File', 'binary.gif'), 'pdf'=>array('PDF Document', 'pdf.gif'),
	                'zip'=>array('Zip File', 'compressed.gif'), '7z'=>array('7Zip File', 'compressed.gif'),
	                'mp3'=>array('MP3 Audio', 'sound.gif'), 'mp4'=>array('MP4 Video', 'video.gif'),
	                '3gp'=>array('3GP Video', 'video.gif'), 'htm'=>array('Web Document', 'html.gif'),
	                'html'=>array('Web Document', 'html.gif'), 'php'=>array('PHP Script', 'script.gif'),
	                'js'=>array('Java Script', 'script.gif'), 'txt'=>array('Text Document', 'text.gif'),
	                'jpeg'=>array('JPEG Image', 'image.gif'), 'jpg'=>array('JPG Image', 'image.gif'),
	                'png'=>array('PNG Image', 'image.gif'), 'gif'=>array('GIF Image', 'image.gif')
	                );
	
	public function Browse($dir)
	{
		$dir_t		= ($dir == '/')? '': $dir;
		$dir_path   = $this->Root_dir.$dir_t;
		
		$files      = $this->CleanupFiles(scandir($dir_path));
		$parent     = $this->GetParentDir($dir);
		$icons      = $this->Icons;
		
		// Generate links
		$links = array();
		$c = 0;
		foreach($files as $file)
		{
			// If entry is a file...
			if(is_file("$dir_path/$file"))
			{
				$links[$c]['name'] = "<font class=\"files\">$file</font>";
				$links[$c]['href'] = htmlspecialchars("{$_SERVER['PHP_SELF']}?req=d&dir=$dir&f=$file");
				$links[$c]['size'] = round(filesize("$dir_path/$file")/(1024*1024), 2).' Mb';
				
				// Get file type & icons
				$fext = strtolower(substr(strrchr($file,"."),1));
				
				if(array_key_exists($fext, $icons))
				{
					$links[$c]['type'] = $icons[$fext][0];
					$links[$c]['icon'] = "iconset/{$icons[$fext][1]}";
				}
				else
				{
					$links[$c]['type'] = 'Unknown File';
					$links[$c]['icon'] = 'iconset/unknown.gif';
				}
			}
			
			// If entry is a folder...
			elseif(is_dir("$dir_path/$file"))
			{
				$links[$c]['name'] = "<font class=\"folders\">$file</font>";
				$links[$c]['icon'] = 'iconset/folder.gif';
				$links[$c]['href'] = htmlspecialchars("{$_SERVER['PHP_SELF']}?req=v&dir=$dir_t/$file");
				$links[$c]['type'] = 'Directory';
				$links[$c]['size'] = '4 Kb';				
			}
			
			$c=$c+1;
		}
		
		
		$directory   = htmlspecialchars("{ root$dir_t }");
		$page_title  = htmlspecialchars("$directory - {$this->Title}");
		$table_title = htmlspecialchars($this->Title);
		$message     = $this->Message;
		$parent_href = htmlspecialchars("{$_SERVER['PHP_SELF']}?req=v&dir=$parent");
		
		ksort($links);
		
		require_once('templates/current.template.php');
		
		exit;
		
	}
	
	private function CleanupFiles($files_array)
	{
		foreach($files_array as $k => $f)
		{
			foreach($this->Exceptions as $e)			
			if(strcasecmp($e, $f) == 0) unset($files_array[$k]);
		}
		return $files_array;
	}
	
	private function GetParentDir($dir)
	{
		$parent = substr($dir, 0, strrpos($dir, '/'));
		return (empty($parent))? '/': $parent;
	}
	
}
?>
