<?php
/*
 *   class.downloader.php - Downloader Class for Indexer
 *   Copyright 2011 Saravana Kumar.A <saravanakumar.a.o@gmail.com>
 *      
 */



class Downloader
{
	public $Root_dir;
	public $AllowedDomains;
	public $AllowedFileTypes;
	public $LogDownloads;
	
	public function Download($file, $dir)
	{
		if(!$this->ValidateDomain())
		die('Internal server error. Please contact domain administrator.');
		if($this->ValidateFile($file, $dir))
		{		
			$dir = ($dir == '/')? '': $dir;
			$this->DownloadFile($this->Root_dir."$dir/$file");
		}
		exit;
	}
	
	private function ValidateDomain()
	{
		if(!$this->AllowedDomains) return true;
		$trigger = false;
		foreach($this->AllowedDomains as $domain)
		{
			if(isset($_SERVER['HTTP_REFERER']))
			if(strpos(strtoupper($_SERVER['HTTP_REFERER']), strtoupper('http://'.$domain)) === 0)
			$trigger = true;
		}
		return $trigger;
	}
	
	private function ValidateFile($file, $dir)
	{
		$fext = strtolower(substr(strrchr($file,"."),1));
		
		if(array_search($fext, $this->AllowedFileTypes) === false)
		{
			$header = "Location: {$_SERVER['PHP_SELF']}?req=v&dir=$dir&e=Error : Not allowed file type : $fext";
			header($header);
			exit;
		}
		
		return true;
	}
	
	private function DownloadFile($file_path)
	{
		require_once('classes/class.httpdownload.php');
		$object = new httpdownload;
		$object->set_byfile($file_path);
		$object->use_resume = true;
		$object->speed = 100;
		$object->log_download = true;
		$object->download();
		return true;
	}
	
}

?>
