<?php
/*
 *   class.processor.php - Query Processor Class for Indexer
 *   Copyright 2011 Saravana Kumar.A <saravanakumar.a.o@gmail.com>
 *      
 */



class QueryProcessor
{
	private $Root_dir;
	private $Title;
	private $Message;
	private $Exceptions;
	private $AllowedFileTypes;
	private $AllowedDomains;
	private $LogDownloads;
	
	private function LoadConfig()
	{
		require_once('config.php');
		
		if(!isset($Root_dir)||!isset($Title)||!isset($Message)||!isset($Exceptions)
		||!isset($AllowedDomains)||!isset($AllowedFileTypes)||!isset($LogDownloads))
		{
			die("<h3>Indexer Configuration error</h3>
			     <a href=\"#\">Some important variables not found</a><br />
				 Please recheck 'config.php' in Indexer directory.");
		}
		
		if(!file_exists($Root_dir)||!is_dir($Root_dir))
		{
			die("<h3>Indexer Configuration error</h3>
				 <a href=\"#\">Root directory is not valid or not readable</a><br />
				 Please recheck 'config.php' in Indexer directory.");
		}
		
		$this->Root_dir = $Root_dir;
		$this->Title = $Title;
		$this->Message = $Message;
		$this->Exceptions = $Exceptions;
		$this->AllowedDomains = $AllowedDomains;
		$this->AllowedFileTypes = $AllowedFileTypes;
		$this->LogDownloads = $LogDownloads;
		return true;
	}
	
	public function ProcessQuery($QUERY)
	{
		if(!isset($QUERY['req']))
			$request = 'view';
		else
		{
			if($QUERY['req'] == 'd')
				$request = 'download';
			else
				$request = 'view';
		}
		
		$this->LoadConfig();
		
		if(!isset($QUERY['dir'])||$QUERY['dir'] == '/')
			$dir = '/';		
		else
		{
			if(strpos($QUERY['dir'], '..') !== false)
			{
				$header = "Location: {$_SERVER['PHP_SELF']}?e=Error : [..] Path hack triggered";
				header($header);
				exit;
			}
						
			if(!is_dir($this->Root_dir.$QUERY['dir']))
			{
				$header = "Location: {$_SERVER['PHP_SELF']}?e=Error : '{$QUERY['dir']}' is not a directory";
				header($header);
				exit;
			}
			
			$dir = $QUERY['dir'];
		}
		
		if(strcmp($request, 'download') == 0)
		{
			if(!isset($QUERY['f'])||empty($QUERY['f'])||strpos($QUERY['f'], '..') !== false)
			{
				$header = "Location: {$_SERVER['PHP_SELF']}?req=v&dir=$dir&e=Error : Invalid file download request";
				header($header);
				exit;
			}
			
			$file = $QUERY['f'];
			
			$file_path = "{$this->Root_dir}$dir/$file";
			
			if(!file_exists($file_path)||!is_file($file_path))
			{
				$header = "Location: {$_SERVER['PHP_SELF']}?req=v&dir=$dir&e=Error : '$file' - File doesn't exist";
				header($header);
				exit;
			}
			
			if(strpos($file, "\0") !== false)
			{
				$header = "Location: {$_SERVER['PHP_SELF']}?req=v&dir=$dir&e=Error : Null byte hack triggered";
				header($header);
				exit;
			}
			
			$downloader = new Downloader();
			$downloader->Root_dir = $this->Root_dir;
			$downloader->AllowedDomains = $this->AllowedDomains;
			$downloader->AllowedFileTypes = $this->AllowedFileTypes;
			$downloader->LogDownloads = $this->LogDownloads;
			$downloader->Download($file, $dir);
			return true;
		}
		
		else
		{
			if(isset($QUERY['e'])&&strlen($QUERY['e'])>5)
			$this->Message = '<font class="error">'.htmlspecialchars($QUERY['e']).'</font>';
			$browser = new Browser();
			$browser->Root_dir = $this->Root_dir;
			$browser->Title = $this->Title;
			$browser->Message = $this->Message;
			$browser->Exceptions = $this->Exceptions;
			$browser->Browse($dir);
			return true;
		}
		
	}

}
