<?php
/**************************************************
 * current.template.php // Template for Indexer
 * (c)2011 Saravaranakumar.A
 * Mail: saravanakumar.a.o@gmail.com
 **************************************************
 * Variables:
 * $page_title - Title of page
 * $table_title - Title to set on top of table
 * $message - Message [Error message]
 * $directory - Current directory
 * $parent_href - Link href of parent directory
 * $links - Contents
 **************************************************/

// Header
echo <<<HEADER
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
	<title>$page_title</title>
	<meta http-equiv="content-type" content="text/html;charset=utf-8" />
	<meta name="generator" content="Geany 0.18" />
	<link rel="stylesheet" href="templates/current.stylesheet.css" />
</head>

<body>
	<div class="table">
		<div class="caption">$table_title</div>
		<div class="message">$message</div>
		<div class="path">Directory: $directory</div>
		<div class="heading">
			<span class="iconcolumn">&nbsp;</span>
			<span class="namecolumn">Item</span>
			<span class="typecolumn">Type</span>
			<span class="sizecolumn">Size</span>
		</div>
		<div class="contents">
			<div class="row" id="parent">
				<a href="$parent_href">
					<span class="iconcolumn">
						<img class="iconimage" src="iconset/up.gif" alt="ico" />
					</span>
					<span class="namecolumn">
						Parent Directory
					</span>
					<span class="typecolumn">
						&nbsp;
					</span>
					<span class="sizecolumn">
						&nbsp;
					</span>
				</a>
			</div>

HEADER;

		// Contents
		foreach($links as $link)
		{
			echo
			<<<CONTENTS
			<div class="row">
				<a href="{$link['href']}">
					<span class="iconcolumn">
						<img class="iconimage" src="{$link['icon']}" alt="ico" />
					</span>
					<span class="namecolumn">
						{$link['name']}
					</span>
					<span class="typecolumn">
						{$link['type']}
					</span>
					<span class="sizecolumn">
						{$link['size']}
					</span>
				</a>
			</div>

CONTENTS;
		}
		
		// Footer
		echo <<<FOOTER
		</div>
	</div>
	<div class="footer">
		Powered by Indexer &copy;2011 Saravana Kumar.A
		<p align="center">
			<a href="http://validator.w3.org/check?uri=referer" target="_blank">
				<img style="border: 0px;" src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0 Transitional" height="31" width="88" />
			</a>
		</p>
	</div>
</body>

</html>
FOOTER;
?>
